#include <gnome.h>
#include "support.h"
#include "memory.h"

#include "custom_view.h"
#include "mp3info.h"
#include "queue.h"
#include "gui_queue.h"
#include "configfile.h"

/***************************************************************************************
 * BELOW FOLLOW THE STATICS
 ***************************************************************************************/

// Return the file size of the given file *fully named*
static void
get_column_order(gchar *name, gchar *order[])
{
	gchar option[2048];
	gchar value[2048];
	gint cur = 0;
	gchar *config = malloc(10000);
	
// read configfile
	config_read(config, 10000);
	
	order[0] = NULL;
	snprintf(option, 2047, "column0#1");
// get correct order from configfile
	while(configfile_option_get(config, name, option, value))
	{
		order[cur] = strdup(value);
		snprintf(option, 2047, "column%i#1", ++cur);
		order[cur] = NULL;
	}
	free(config);
}

// Removes all items from haystack that have a filename AND directory that is in needle.
static GList *
g_list_remove_matching_filenames(GList *haystack, GList *needle)
{
	GList *haystack_item = NULL;
	GList *needle_item = NULL;
	Mp3Info *haystack_mp3info = NULL;
	Mp3Info *needle_mp3info = NULL;

	haystack_item = g_list_first(haystack);
	while(haystack_item)
	{
		haystack_mp3info = (Mp3Info *)haystack_item->data;
		haystack_item = g_list_next(haystack_item);
		
		needle_item = g_list_first(needle);
		while(needle_item)
		{
			needle_mp3info = (Mp3Info *)needle_item->data;
			needle_item = g_list_next(needle_item);
			if(strncmp(needle_mp3info->filename, haystack_mp3info->filename, 2048)==0
				&& strncmp(needle_mp3info->directory, haystack_mp3info->directory, 2048)==0 )
			{
				haystack = mem_free_1(haystack, haystack_mp3info);
				break;
			}
		}
	}
	return g_list_first(haystack);
}

/***************************************************************************************
 * END OF STATICS
 ***************************************************************************************/


void
custom_view_add(void)
{
	extern GtkWidget *custom_view;
	extern GtkWidget *gmp3;
	extern GList *queue;
	GList *foundfiles = NULL;
	Mp3Info *mp3info = NULL;
	GtkCList *clist_custom_view_files = NULL;
	gchar *order[30];
	gint cur = -1;

	clist_custom_view_files = GTK_CLIST(lookup_widget(custom_view, "clist_custom_view_files"));
	
// get the wished column style/order from the configfile
	get_column_order("queue columns", order);
// set the column titles
	clist_queue_set_titles(GTK_CLIST(lookup_widget(gmp3, "clist_gmp3_queue")), order);
	clist_queue_set_titles(GTK_CLIST(lookup_widget(gmp3, "clist_gmp3_queueonly_queue")), order);
	
	while( (mp3info = gtk_clist_get_row_data(clist_custom_view_files, ++cur)) )
		foundfiles = g_list_append(foundfiles, mp3info);

	foundfiles = g_list_remove_matching_filenames(foundfiles, queue);
	queue = g_list_concat(queue, foundfiles);
	
	clist_queue_add_files(GTK_CLIST (lookup_widget (gmp3, "clist_gmp3_queue")), &foundfiles, order);
	clist_queue_add_files(GTK_CLIST (lookup_widget (gmp3, "clist_gmp3_queueonly_queue")), &foundfiles, order);

	cur = -1;
	while(order[++cur])
		free(order[cur]);
	
	gtk_widget_destroy(custom_view);
	return;
}
