/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include "support.h"

#include "freedb.h"
#include "lib_freedb.h"
#include "gui_freedb.h"
#include "mp3info.h"

void
clist_album_choose_albums_add(GList *cdlist)
{
	extern GtkWidget *tracks_sort;
	
	CDInfo *cd = NULL;
	GList *listitem = NULL;
	gchar *row[3];
	
	listitem = g_list_first(cdlist);
	
	while(listitem)
	{
		cd = (CDInfo *)listitem->data;
		row[0] = cd->cdtitle;
		row[1] = cd->genre;
		row[2] = malloc(9);
		snprintf(row[2], 9, "%08lx", cd->id);
		
		gtk_clist_set_row_data(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_cdlist")),
			gtk_clist_append(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_cdlist")), row),
			cd);
		
		free(row[2]);		
		listitem = listitem->next;
	}
// cleanup
	gtk_clist_sort(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_cdlist")));
	gtk_clist_columns_autosize(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_cdlist")));
	return;
}



void
clist_tracks_sort_tracks_add(CDInfo *cd)
{
	extern GtkWidget *gmp3;
	extern GtkWidget *tracks_sort;
	gchar *rowdata[4];
	gint row = 0;

	row = -1;
	while(cd->track[++row])
	{
		rowdata[1] = "->";
		rowdata[2] = malloc(5);
		snprintf(rowdata[2], 4, "%i", row+1);
		rowdata[3] = ((CDTrack *)cd->track[row])->title;
		
		if(gtk_clist_get_row_data(GTK_CLIST(lookup_widget(gmp3, "clist_gmp3_queue")), row)!=NULL)
		{
			rowdata[0] = malloc(2048);
			snprintf( rowdata[0], 2047, "%s%s",
				((Mp3Info *)gtk_clist_get_row_data(GTK_CLIST(lookup_widget(gmp3, "clist_gmp3_queue")), row))->directory,
				((Mp3Info *)gtk_clist_get_row_data(GTK_CLIST(lookup_widget(gmp3, "clist_gmp3_queue")), row))->filename );
		}
		else
			rowdata[0] = NULL;
		
		gtk_clist_set_row_data(
			GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks")),
			gtk_clist_append(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks")), rowdata), cd );

		if(rowdata[0])
			free(rowdata[0]);
		free(rowdata[2]);
	}
	gtk_clist_columns_autosize(GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks")));
}












void
clist_tracks_move_track_down(void)
{
	extern GtkWidget *tracks_sort;
	GtkCList *clist = NULL;
	GList *selection = NULL;
	gchar *foo = NULL;
	gint row = -1;
	gboolean stopit = FALSE;
	gchar temp[2048];
	gchar track[20];

	clist = GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks"));
// count rows in clist
	while(gtk_clist_get_text (clist, ++row, 2, &foo));

// and toggle swap each selected item with its followed one (if one is present)
	while (row >= 0)
	{
		selection = clist->selection;
		while (selection)
		{
			if((gint)selection->data==row)
			{
				if(gtk_clist_get_text (clist, row+1, 2, &foo))
				{
					gtk_clist_get_text (clist, row, 2, &foo);
					strncpy(track, foo, 2047);
					gtk_clist_get_text (clist, row, 3, &foo);
					strncpy(temp, foo, 2047);
					
					gtk_clist_get_text (clist, row+1, 2, &foo);
					gtk_clist_set_text(clist, row, 2, foo);
					gtk_clist_get_text (clist, row+1, 3, &foo);
					gtk_clist_set_text(clist, row, 3, foo);
					
					gtk_clist_set_text(clist, row+1, 2, track);
					gtk_clist_set_text(clist, row+1, 3, temp);
					
					gtk_clist_unselect_row(clist, row, 2);
					gtk_clist_select_row(clist, row+1, 2);
				}
				else
					stopit=TRUE;
				break;
			}
			selection = selection->next;
		}
		if(stopit) break;
		--row;
	}
}
















void
clist_tracks_move_track_up(void)
{
	extern GtkWidget *tracks_sort;
	GtkCList *clist = NULL;
	GList *selection = NULL;
	gchar *foo = NULL;
	gint row = -1;
	gboolean stopit = FALSE;
	gchar temp[2048];
	gchar track[20];
	gint max = -1;

	clist = GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks"));
// count rows	
	while(gtk_clist_get_text (clist, ++max, 2, &foo));

// swap each selected item with the previous one (if present)
	while (row < max)
	{
		selection = clist->selection;
		while (selection)
		{
			if((gint)selection->data==row)
			{
				if(gtk_clist_get_text (clist, row-1, 2, &foo))
				{
					gtk_clist_get_text (clist, row, 2, &foo);
					strncpy(track, foo, 2047);
					gtk_clist_get_text (clist, row, 3, &foo);
					strncpy(temp, foo, 2047);
					
					gtk_clist_get_text (clist, row-1, 2, &foo);
					gtk_clist_set_text(clist, row, 2, foo);
					gtk_clist_get_text (clist, row-1, 3, &foo);
					gtk_clist_set_text(clist, row, 3, foo);
					
					gtk_clist_set_text(clist, row-1, 2, track);
					gtk_clist_set_text(clist, row-1, 3, temp);
					
					gtk_clist_unselect_row(clist, row, 2);
					gtk_clist_select_row(clist, row-1, 2);
				}
				else
					stopit=TRUE;
				break;
			}
			selection = selection->next;
		}
		if(stopit) break;
		++row;
	}
}







CDInfo *
clist_tracks_sort_get_tracks(void)
{
	extern GtkWidget *tracks_sort;
	GtkCList *clist = NULL;
	gint row = 0;
	CDInfo *cd = NULL;
	gchar *temp = malloc(2048);
	
	clist = GTK_CLIST(lookup_widget(tracks_sort, "clist_tracks_sort_tracks"));
	
	cd = gtk_clist_get_row_data(clist, 0);
	
	if(cd)
	{
		while( gtk_clist_get_text(clist, row, 0, &temp) )
		{
			strncpy( ((CDTrack *)cd->track[row++])->filename, temp, 2048 );
			*((CDTrack *)cd->track[row])->filename = '\0';
		}
	}
	free(temp);
	
	return cd;
}
