/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <gnome.h>
#include "support.h"

#include "genre.h"
#include "tageditor.h"
#include "gui_tageditor.h"

void
tageditor_tag_to_gui(id3Tag *tag, gint mode)
{
	extern GtkWidget *gmp3;
	gint mygenre = 0;
	gchar *foobar = NULL;

// put the tag to the form (mode 0)
	if(mode==0)
	{
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_artist")), tag->artist);
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_song")), tag->title);
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_album")), tag->album);
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_year")), tag->year);
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_track")), tag->track);
		gtk_text_insert(GTK_TEXT (lookup_widget (gmp3, "text_gmp3_tagedit_comment")), NULL, NULL, NULL, tag->comment, -1);
		if((tag->genre&127)>125)
			mygenre = 12;
		else
			mygenre = tag->genre;
		
		gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_genre")), genre[mygenre]);
	}
	else
	{
// or delete where tag does not match the already selected tags (mode 1).
		if(strcmp(gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_artist"))), tag->artist))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_artist")), "");
		if(strcmp(gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_song"))), tag->title))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_song")), "");
		if(strcmp(gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_album"))), tag->album))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_album")), "");
		if(strcmp(gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_year"))), tag->year))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_year")), "");
		if(strcmp(gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_track"))), tag->track))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_track")), "");
		
		foobar = gtk_editable_get_chars(GTK_EDITABLE (lookup_widget (gmp3, "text_gmp3_tagedit_comment")), 0,
			gtk_text_get_length(GTK_TEXT (lookup_widget (gmp3, "text_gmp3_tagedit_comment"))));
		if(strcmp(foobar, tag->comment))
		{
			gtk_text_set_point(GTK_TEXT(lookup_widget (gmp3, "text_gmp3_tagedit_comment")), 0);
			gtk_text_forward_delete(GTK_TEXT (lookup_widget (gmp3, "text_gmp3_tagedit_comment")), 
				gtk_text_get_length(GTK_TEXT (lookup_widget (gmp3, "text_gmp3_tagedit_comment"))));
		}
		free(foobar);
		
		if((tag->genre&127)>125)
			mygenre = 12;
		else
			mygenre = tag->genre;
		
		if(strcmp(genre[mygenre], gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_genre")))))
			gtk_entry_set_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_genre")), "");
	}
}






void
tageditor_gui_to_tag(id3Tag *tag)
{
	extern GtkWidget *gmp3;
	gint i = 0;
	
// Overwrite tag where user wants to set new fields
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, "check_gmp3_tagedit_song"))))
		strncpy(tag->title, gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_song"))), 1023);
	
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, "check_gmp3_tagedit_artist"))))
		strncpy(tag->artist, gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_artist"))), 1023);
	
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, "check_gmp3_tagedit_album"))))
		strncpy(tag->album, gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_album"))), 1023);

	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, "check_gmp3_tagedit_year"))))
		strncpy(tag->year, gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_year"))), 1023);

	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, "check_gmp3_tagedit_comment"))))
		strncpy(tag->comment,
		gtk_editable_get_chars(GTK_EDITABLE (lookup_widget (gmp3, "text_gmp3_tagedit_comment")), 0,
			gtk_text_get_length(GTK_TEXT (lookup_widget (gmp3, "text_gmp3_tagedit_comment")))),
		1023);

	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, "check_gmp3_tagedit_track"))))
		strncpy(tag->track,
			gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_track"))), 3);
	
	if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON (lookup_widget (gmp3, "check_gmp3_tagedit_genre"))))
	{
		for(i=0;i<=147;i++)
		{
			if(strcmp(genre[i], gtk_entry_get_text(GTK_ENTRY (lookup_widget (gmp3, "entry_gmp3_tagedit_genre"))))==0)
				tag->genre = i;
		}
	}
}

