/* the gmp3 project.
 * (c)2002 by Samuel Abels (sam@manicsadness.com)
 * This project's homepage is: http://software.manicsadness.com/gmp3
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef id3Tag_def
#define id3Tag_def
typedef struct id3Tag_s
{
	gchar title[1024];
	gchar artist[1024];
	gchar album[1024];
	gchar year[5];
	gchar comment[1024];
	gchar track[3];
	guchar genre;
	guint size;
	gboolean has_footer;
} id3Tag;
#endif

typedef struct id3v2Tag_s
{
	gboolean unsync;
	gboolean has_extheader;
	gboolean is_experimental;
	gboolean has_footer;
	guint tag_size;
	guint extheader_size;
	gboolean is_update;
	gboolean crc_data_present;
	gboolean restrictions;
	guint flag_bytes;
	guint crc_data_length;
	guchar *crc_data;
	guint restrictions_data_length;
	guchar *restrictions_data;
	GList *frames;
} id3v2Tag;

typedef struct id3v2Frame_s
{
	guchar *frame_id;
	guint frame_datasize;
	guchar frame_statusflag;
	guchar frame_formatflag;
	guchar *frame_data;
} id3v2Frame;

extern int get_id3v2_tag(id3Tag *tag, gchar *filename);
extern int set_id3v2_tag(id3Tag *tag, gchar *filename);
extern int del_id3v2_tag(gchar *filename);
